<template>
  <input
    :value="modelValue"
    @input="updateValue"
    v-if="type != 'select'"
    :type="type"
  />
  <select v-else :value="modelValue" @input="updateValue">
    <slot></slot>
  </select>
</template>

<script>
export default {
  props: {
    modelValue: {
      default: "",
    },
    type: {
      type: String,
      required: true,
      default: null,
    },
    icon: {
      type: String,
      required: false,
      default: null,
    },
  },
  computed: {
    iconSrc() {
      return require("@/assets/" + this.icon);
    },
  },
  methods: {
    updateValue(event) {
      this.$emit("update:modelValue", event.target.value);
    },
  },
};
</script>

<style scoped>
input,
select {
  width: 100%;
  outline: none;
  border: 1px solid hsl(var(--clr-form-field-border));
  border-radius: 4px;
  padding: 0.5rem;
  background: hsl(var(--clr-form-field-bg));
  color: hsl(var(--clr-text-body-b));
}
input:focus {
  border: 1px solid hsl(var(--clr-form-field-border-hover));
  background: hsl(var(--clr-form-field-bg));
}
input[type="date"]::-webkit-calendar-picker-indicator {
  background: url("@/assets/icon-calendar.svg") no-repeat;
}
input:disabled {
  border: none;
  background: transparent;
}
input::placeholder {
  color: hsl(var(--clr-text-placeholder));
}
input::-webkit-outer-spin-button,
input::-webkit-inner-spin-button {
  -webkit-appearance: none;
  margin: 0;
}

/* Firefox */
input[type="number"] {
  -moz-appearance: textfield;
}
.invalid input,
.invalid input:focus {
  border: 1px solid hsl(var(--clr-danger));
}
</style>
